# Demos for functions

# Miscalculates
def bad_power(a,b):
    for i in range (b-1):
        a = a * a
    return (a)

print("Bad Power",bad_power(5,2))
print("Bad Power",bad_power(5,4))
print("Bad Power",bad_power(5,0))

# Clumsy
def poor_power(a,b):
    r=a
    for i in range (b-1):
        r = r * a
    return (r)

print("Poor Power",poor_power(5,2))
print("Poor Power",poor_power(5,4))
print("Poor Power",poor_power(5,0))

# Calculates powers for positive integers
# Implements algorithm 1*a*a*a... n times for a to n
def power(base,exponent):
    result=1
    for i in range (exponent):
        result = base * result
    return (result)

print("Good Power",power(5,2))
print("Good Power",power(5,4))
print("Good Power",power(5,0))

# We can use while instead of for an range, it works, too
def while_power(base, exponent):
    result = 1
    while exponent > 0:
        result = result*base
        exponent = exponent - 1
    return result

# A test for the power function
if power(5,2) == 25:
    print("Pass")
else:
    print("Fail")

# Testing border conditions
if power(5,0) == 1:
    print("Pass")
else:
    print("Fail")

# Testing to see if it matches another known function
for i in range(-5,5):
    t = power(5, i)
    if t == 5 ** i:         # ** is the power function in Python
        print("Pass")
    else:
        print("Fail",i,t)

# A more generic test function to test any function
# Note that in Python the function can be passed as a parameter (not required to know at Y1)
# Note also the difference between snake_style and camelCase naming conventions

def generic_test(functionName, input, expectedResult):
    testResult = functionName(*input)       # The asterisk unpacks a list to parameters
    if  testResult == expectedResult:
        print("Pass", input, testResult)
    else:
        print("FAIL", input, testResult, expectedResult)

generic_test(power,[5,1],5)
generic_test(power,[5,4],625)
generic_test(power,[5,100],7.88860905221012e69)
generic_test(power,[5,2],25)
generic_test(power,[5,0],1)
generic_test(power,[5,-1],0.2)